#!/usr/local/bin/python2.6
#encoding: utf-8

##
## Este programa pega um array com intensidades de pixel de Ncor
## canais, em linhas com Npix colunas, e obtidos de Npos posições
## diferentes, encontra picos em cada linha e grava em um arquivo de
## saída um alista contendo as eviências em cada posição, isto é, uma
## lista com os valores do inverso da coluna em que se localizam os
## picos detectados.


import numpy

import sys


if len(sys.argv)<=1:
    print "Usage: ", sys.argv[0], "arquivo_pixels.npy arquivo_Z.pkl"
    exit 


## Carrega arquivo com as cadeias de pixels. Intensidades originais,
## extraídas das imagens.
dados = numpy.load(sys.argv[1])

Npos, Npix, Ncor = dados.shape    # Número de posições, pixels e canais
print 'Npos', Npos, 'Npix', Npix


## Filtro de derivada + suavização.
myfilt = numpy.convolve( numpy.array([ 1, 1 ])/2., numpy.array([1,0,-1 ])/2.0  )
Nfil = myfilt.shape[0] # Tamanho do filtro

print 'filter:',myfilt

## Número de amostras 'válidas' entregues após a convolução com mode='valid'
Nv = numpy.max([Npix, Nfil]) - numpy.min([Npix, Nfil]) + 1



Z = []

##
## Pega cada cadeia, deriva, encontra os picos e joga na lista de
## evidências amostradas o valor de w_i = z_i^-1. Valor de w_i deve
## ser limitado (i.e. desconsiderar z_i perto de 0)
for k in xrange(0,Npos):  #Npos):

    print k,':'
    ## Cadeia filtrada
    vv = numpy.zeros((Nv, Ncor))

    ## Para cada posição, filtra cada canal e joga em vv
    for c in xrange(Ncor):
        vv[:,c] = numpy.convolve(dados[k,:,c], myfilt, mode='valid')

    vpk = numpy.sum( vv**2 , 1)
    #print 'vpk',vpk

    ## Só pra avaliar o jeitao... Solta média e desvio padrão.
    print "µ:", numpy.mean(vpk), 'σ:', numpy.std(vpk)

    ## Limiariza por 3 ou 4 vezes o desvio padrão

    #limiar = 3*0.003  # 
    limiar = 1*numpy.std(vpk)
    #limiar = 0

    pks = numpy.nonzero(vpk > limiar)[0]  ## Localizações dos valores selecionados
    pks = pks[ (pks>0) * (pks<Nv-1) ]  ## Não considera nada nas bordas
    pks = pks[(vpk[pks] > vpk[pks-1]) *(vpk[pks] > vpk[pks+1])]  ## Máximos locais (picos)
    #print 'pks', pks

    z = numpy.array(pks, dtype=float)/(Npix/2) - 1.0 ## Coordenadas normalizadas dos pixels
    faixa_dentro = 10.0
    faixa_fora = Npix/2.-10
    z = z[numpy.abs(z) > (faixa_dentro*2)/Npix]  ## Seleciona só os picos fora da faixa central de 20 pixels
    z = z[numpy.abs(z) < (faixa_fora*2)/Npix]  ## Seleciona só os picos fora da faixa central de 20 pixels
    w = z**-1                         ## Inverso dos valores
    
    ## Joga na lista de evidências
    Z.append( list(w) )
    
    print Z[-1]
    print



##
##
## Salva a lista de evidências, Z em um arquivo
import pickle
output = open(sys.argv[2], 'wb')
pickle.dump(Z, output, -1)
output.close()



